using System.Text.Json.Serialization;

namespace Luski.Clesses;

public class ServerList
{
    [JsonInclude]
    [JsonPropertyName("servers")]
    public ServerInfo[] Server { get; set; } = new []
    {
        new ServerInfo()
        {
            Domain = "10.100.0.10:5287",
            Version = "v1",
            Main = false,
            Secure = false
        }
    };
}

[JsonSerializable(typeof(ServerList))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.Unspecified,
    WriteIndented = true,
    DefaultIgnoreCondition = JsonIgnoreCondition.Never)]
internal partial class ServerListContext : JsonSerializerContext
{

}